//////////////////////////////////////////////////////////////////////////////
// color.cpp - Source file of "Color" project, written by Daniel Trifonov
// Copyright (C) 2001 Daniel Trifonov. All rights reserver.
//
// http://daniel.dir.bg , e-mail: d3@dir.bg
//////////////////////////////////////////////////////////////////////////////

#include <stdio.h>

class SecondCo {
public:
	int uiSecondCo : 12;
	SecondCo *pNext;

	SecondCo( unsigned position, SecondCo *next) {
		uiSecondCo = position;
		pNext = next;
	}
};

class Flags {
public:
	int Flag : 2;
	SecondCo *pWhites, *pBlacks;
};


FILE *fpInput, *fpOutput;
unsigned int i, N;
int x, y, color, Found;
SecondCo *pCurr, *prev, *q;
Flags xFlags[2001], yFlags[2001];



void main()
{
	// Display program logo
	printf( "COLOR.EXE - written by task of PC Magazine Bulgaria Jan 2001\n");
	printf( "Copyright (C) 2001 Daniel Trifonov. All rights reserved.\n\n");


	// Open Input and Output files
	if ( !(fpInput = fopen( "color.INP", "rt")) ) return;
	if ( !(fpOutput = fopen( "color.OUT", "wt")) ) return;

	// Reading input data - Number of points
	fscanf( fpInput, "%u", &N);
	// Reading input data - points position
	for ( i=N; i; i--) { 
		fscanf( fpInput, "%d %d", &x, &y);
//		fscanf( fpInput, "%d", &x);
//		fscanf( fpInput, "%d", &y);
		// correction
		x += 1000;
		y += 1000;

		// !!! 
		if ( !(xFlags[x].Flag || yFlags[y].Flag) || 
			( (xFlags[x].Flag & 2)==2 && (!yFlags[y].Flag || (yFlags[y].Flag & 2)==2) ) || 
			( (yFlags[y].Flag & 2)==2 && (!xFlags[x].Flag || (xFlags[x].Flag & 2)==2) ) ) 
		{
			// black point
//			color = 1;
			// PC1
			xFlags[x].pBlacks = new SecondCo( y, xFlags[x].pBlacks);
			yFlags[y].pBlacks = new SecondCo( x, yFlags[y].pBlacks);

			xFlags[x].Flag++;
			yFlags[y].Flag++;
//			if (xFlags[x].Flag) xFlags[x].Flag = 0; else xFlags[x].Flag = 1;
//			if (yFlags[y].Flag) yFlags[y].Flag = 0; else yFlags[y].Flag = 1;
		}
		else 
			// !!! 
			if ( xFlags[x].Flag == 1 && (!yFlags[y].Flag || yFlags[y].Flag == 1) || 
				yFlags[y].Flag == 1 && (!xFlags[x].Flag || xFlags[x].Flag == 1) ) 
			{ 
				// white point
//				color = 0;
				// PC2
				xFlags[x].pWhites = new SecondCo( y, xFlags[x].pWhites);
				yFlags[y].pWhites = new SecondCo( x, yFlags[y].pWhites);

				xFlags[x].Flag--;
				yFlags[y].Flag--;
//				if (xFlags[x].Flag) xFlags[x].Flag = 0; else xFlags[x].Flag = -1;
//				if (yFlags[y].Flag) yFlags[y].Flag = 0; else yFlags[y].Flag = -1;
			}
			else { 
				// PC3
				Found = 0;
				color = !(xFlags[x].Flag >> 1 & 1);
				if (color) pCurr = xFlags[x].pBlacks;
				else pCurr = xFlags[x].pWhites;
				while (pCurr) {
					if (xFlags[x].Flag == yFlags[pCurr->uiSecondCo].Flag) {
						if (color) {
							xFlags[x].pWhites = new SecondCo( pCurr->uiSecondCo, xFlags[x].pWhites);
							yFlags[pCurr->uiSecondCo].pWhites = new SecondCo( x, yFlags[pCurr->uiSecondCo].pWhites);
							yFlags[pCurr->uiSecondCo].Flag = -1;

							q = yFlags[pCurr->uiSecondCo].pBlacks;
							if (q->uiSecondCo == x) {
								yFlags[pCurr->uiSecondCo].pBlacks = q->pNext;
								q->pNext = yFlags[y].pBlacks;
								yFlags[y].pBlacks = q;
							}
							else {
								do { prev = q; q = q->pNext;
								} while (q->uiSecondCo != x);
								prev->pNext = q->pNext;
								q->pNext = yFlags[y].pBlacks;
								yFlags[y].pBlacks = q;
							}
						}
						else {
							xFlags[x].pBlacks = new SecondCo( pCurr->uiSecondCo, xFlags[x].pBlacks);
							yFlags[pCurr->uiSecondCo].pBlacks = new SecondCo( x, yFlags[pCurr->uiSecondCo].pBlacks);
							yFlags[pCurr->uiSecondCo].Flag = 1;

							q = yFlags[pCurr->uiSecondCo].pWhites;
							if (q->uiSecondCo == x) {
								yFlags[pCurr->uiSecondCo].pWhites = q->pNext;
								q->pNext = yFlags[y].pWhites;
								yFlags[y].pWhites = q;
							}
							else {
								do { prev = q; q = q->pNext;
								} while (q->uiSecondCo != x);
								prev->pNext = q->pNext;
								q->pNext = yFlags[pCurr->uiSecondCo].pBlacks;
								yFlags[pCurr->uiSecondCo].pBlacks = q;
							}
						}
						pCurr->uiSecondCo = y;
						xFlags[x].Flag = yFlags[y].Flag = 0;
						Found = 1;
						break;
					}
					else pCurr = pCurr->pNext;
				}
				if (!Found) {
					// PC4
//					color = !color;
					color = !(yFlags[y].Flag >> 1 & 1);
					if (color) pCurr = yFlags[y].pBlacks;
					else pCurr = yFlags[y].pWhites;
					while (pCurr) {
						if (yFlags[y].Flag == xFlags[pCurr->uiSecondCo].Flag) {
							if (color) {
								yFlags[y].pWhites = new SecondCo( pCurr->uiSecondCo, yFlags[y].pWhites);
								xFlags[pCurr->uiSecondCo].pWhites = new SecondCo( y, xFlags[pCurr->uiSecondCo].pWhites);
								xFlags[pCurr->uiSecondCo].Flag = -1;

								q = xFlags[pCurr->uiSecondCo].pBlacks;
								if (q->uiSecondCo == y) {
									xFlags[pCurr->uiSecondCo].pBlacks = q->pNext;
									q->pNext = xFlags[x].pBlacks;
									xFlags[x].pBlacks = q;
								}
								else {
									do { prev = q; q = q->pNext;
									} while (q->uiSecondCo != y);
									prev->pNext = q->pNext;
									q->pNext = xFlags[x].pBlacks;
									xFlags[x].pBlacks = q;
								}
							}
							else {
								yFlags[y].pBlacks = new SecondCo( pCurr->uiSecondCo, yFlags[y].pBlacks);
								xFlags[pCurr->uiSecondCo].pWhites = new SecondCo( y, xFlags[pCurr->uiSecondCo].pBlacks);
								xFlags[pCurr->uiSecondCo].Flag = 1;

								q = xFlags[pCurr->uiSecondCo].pWhites;
								if (q->uiSecondCo == y) {
									xFlags[pCurr->uiSecondCo].pWhites = q->pNext;
									q->pNext = xFlags[x].pWhites;
									xFlags[x].pWhites = q;
								}
								else {
									do { prev = q; q = q->pNext;
									} while (q->uiSecondCo != y);
									prev->pNext = q->pNext;
									q->pNext = xFlags[x].pWhites;
									xFlags[x].pWhites = q;
								}
							}
							pCurr->uiSecondCo = x;
							yFlags[y].Flag = xFlags[x].Flag = 0;
							break;
						}
						else pCurr = pCurr->pNext;
					}
				}
			}

	}

	// Write the results
	for ( i = 0; i < 2001; i++) {
		pCurr = xFlags[i].pWhites;
		while (pCurr) {
			fprintf( fpOutput, "%d %d 0\n", i - 1000, pCurr->uiSecondCo - 1000);
			pCurr = pCurr->pNext;
		}
		pCurr = xFlags[i].pBlacks;
		while (pCurr) {
			fprintf( fpOutput, "%d %d 1\n", i - 1000, pCurr->uiSecondCo - 1000);
			pCurr = pCurr->pNext;
		}
	}


	fcloseall();

	return;
}
