// THE COLOR POINTS PROBLEM
// Solved By Backtracing method...
// Author: Dimiter Dimitrov
// E-Mail: mindarelus@yahoo.com

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>

#define MaxN    10000
#define	INFILE  "color.inp"
#define OUTFILE "color.out"

int n,x[MaxN],y[MaxN],c[MaxN];

void FileErrMsg(int ErrCode) {
printf("ERROR%d: FILE NOT FOUND...",ErrCode); exit(0);
}

void ReadData() {
FILE *fp;
if((fp=fopen(INFILE,"r"))==NULL) FileErrMsg(1);
fscanf(fp,"%d",&n);
for(int i=1;i<=n;i++) fscanf(fp,"%d%d",&x[i],&y[i]);
fclose(fp);
}

void WriteData() {
FILE *fp;
if((fp=fopen(OUTFILE,"w"))==NULL) FileErrMsg(2);
for(int i=1;i<=n;i++) fprintf(fp,"%d %d %d\n",x[i],y[i],c[i]);
fclose(fp);
}

void CheckValid(int t,int &vx,int &vy) {
int SumWX=0,SumWY=0,SumBX=0,SumBY=0;
for(int i=1;i<=t-1;i++) {
 if(x[i]==x[t]) if(c[i]) SumBX++; else SumWX++;
 if(y[i]==y[t]) if(c[i]) SumBY++; else SumWY++; }
vx=SumBX-SumWX; vy=SumBY-SumWY;
}

void BackTrace(int Depth) {
if(Depth>n) { WriteData(); exit(0); }
int ValidX=0,ValidY=0;
CheckValid(Depth,ValidX,ValidY);
if(abs(ValidX-1)<=1&&abs(ValidY-1)<=1) { c[Depth]=0; BackTrace(Depth+1); }
if(abs(ValidX+1)<=1&&abs(ValidY+1)<=1) { c[Depth]=1; BackTrace(Depth+1); }
}

void main() {
ReadData();
BackTrace(1);
}