#include <stdio.h>

class CPoint
{
public:
	int x, y;
	CPoint *next_x, *next_y;
	CPoint ();
	void SetXY (int xx, int yy);
};

class CLists
{
private:
	CPoint* x_head[2001];
	CPoint* x_tail[2001];
	CPoint* y_head[2001];
	CPoint* y_tail[2001];
public:
	CLists ();
	void AddPoint (CPoint& p);
	CPoint* GetPointX (int);
	CPoint* GetPointY (int);
};

void Solve (int, int, int, int);
void test();

FILE *fin = fopen ("color.inp", "rt");
FILE *fout = fopen ("color.out", "wt");

char Data[2001][2001];
CPoint AllPoints[15001];
CLists Link;


int main (void)
{
	int n, x, y, i;

	fscanf (fin, "%d", &n);
	for (i = 0; i < n; i++)
	{
		fscanf (fin, "%d%d", &x, &y);
		x += 1000;
		y += 1000;
		Data[x][y] = 1;
		AllPoints[i].SetXY (x, y);
		Link.AddPoint (AllPoints[i]);
	}

	Solve (-1, -1, -1, n);

	fclose (fin);
	fclose (fout);
	return 0;
}

void Solve (int x, int y, int color, int n)
{
	static int all_index = 0; 
	int x2, y2;
	CPoint *tmp, *found_x, *found_y;

	if (x == -1 && y == -1)
	{
		for (int i = all_index; i < n; i++)
			if (Data[AllPoints[i].x][AllPoints[i].y] == 1)
				break;

		if (i == n) return;
		all_index = i;
		x = AllPoints[i].x;
		y = AllPoints[i].y;
	}

	Data[x][y] = 0;

	found_y = Link.GetPointX (x);
	if (found_y != NULL)
		y2 = found_y->y;

	found_x = Link.GetPointY (y);
	if (found_x != NULL)
		x2 = found_x->x;

	if (color == -1)
	{
		fprintf (fout, "%d %d %d\n", x - 1000, y - 1000, 0);
		color = 1;
	}

	if (!found_x && !found_y)
		Solve(-1, -1, -1, n);

	if (found_x && found_y)
	{
		fprintf (fout, "%d %d %d\n", x - 1000, y2 - 1000, color);
		fprintf (fout, "%d %d %d\n", x2 - 1000, y - 1000, color);
		Data[x][y2] = Data[x2][y] = 0;

		if (Data[x2][y2] == 1)
		{
			fprintf (fout, "%d %d %d\n", x2 - 1000, y2 - 1000, 1-color);
			Data[x2][y2] = 0;
			Solve(-1, -1, -1, n);
		}
		else 
			Solve(x2, y2, 1-color, n);
	}

	if (found_x && !found_y)
	{
		fprintf (fout, "%d %d %d\n", x2 - 1000, y - 1000, color);
		Data[x2][y] = 0;

		tmp = Link.GetPointX (x2);
	
		if (tmp == NULL)
			Solve(-1, -1, -1, n);
		else
		{
			fprintf (fout, "%d %d %d\n", x2 - 1000, tmp->y - 1000, 1-color);
			Data[x2][tmp->y] = 0;
			Solve (x, tmp->y, color, n);
		}
	}
	if (!found_x && found_y)
	{
		fprintf (fout, "%d %d %d\n", x - 1000, y2 - 1000, color);
		Data[x][y2] = 0;

		tmp = Link.GetPointY (y2);

		if (tmp == NULL)
			Solve (-1, -1, -1, n);
		else
		{
			fprintf (fout, "%d %d %d\n", tmp->x - 1000, y2 - 1000, 1-color);
			Data[tmp->x][y2] = 0;
			Solve (tmp->x, y, color, n);
		}
	}
}

inline CPoint::CPoint () 
{
	next_x = next_y = NULL;
}
inline void CPoint::SetXY (int xx, int yy) 
{
	x = xx;  
	y = yy;
}
CLists::CLists ()
{
	for (int i = 0; i < 2001; i++) 
		x_head[i] = x_tail[i] = y_head[i] = y_tail[i] = NULL;
}
void CLists::AddPoint (CPoint& p)
{
	if (x_head[p.x] == NULL) x_head[p.x] = x_tail[p.x] = &p;
	else {
		x_tail[p.x]->next_x = &p;
		x_tail[p.x] = x_tail[p.x]->next_x;
	}
	if (y_head[p.y] == NULL) y_head[p.y] = y_tail[p.y] = &p;
	else {
		y_tail[p.y]->next_y = &p;
		y_tail[p.y] = y_tail[p.y]->next_y;
	}
}
CPoint* CLists::GetPointY (int index)
{
	while (y_head[index] != NULL && Data[y_head[index]->x][y_head[index]->y] == 0)
		y_head[index] = y_head[index]->next_y;
	return y_head[index];
}
CPoint* CLists::GetPointX (int index)
{
	while (x_head[index] != NULL && Data[x_head[index]->x][x_head[index]->y] == 0)
		x_head[index] = x_head[index]->next_x;
	return x_head[index];
}
