/* compiled with djgpp */
#include <iostream.h>
#include <string.h>
#include <stdlib.h>
#include <fstream.h>

#define MAXN 15010

#define RAD 3
#define RAT 15
#define MAXADJ 4
#define MAXCOOR 2000

struct point {
  int x,y;
  int num, color;
  int comp;

  int ar[MAXADJ];
  int count;
};

int   n;
point p[MAXN];
int   comps;
int   solved[MAXN];

void readdata()
{
   int	    i;
   ifstream fin("color.inp");

   fin >> n;
   for(i=1;i<=n;i++)
   {
      fin >> p[i].x >> p[i].y;
      p[i].num = i;
   }

   fin.close();
}

int cmpx(const void *ac, const void *bc)
{
   point a,b;

   a = *(point *) ac;
   b = *(point *) bc;

   if(a.x > b.x) return 1; if(a.x < b.x) return -1;
   if(a.y > b.y) return 1; if(a.y < b.y) return -1;
   return 0;
}

int cmpy(const void *ac, const void *bc)
{
   point a,b;

   a = *(point *) ac;
   b = *(point *) bc;

   if(a.y > b.y) return 1; if(a.y < b.y) return -1;
   if(a.x > b.x) return 1; if(a.x < b.x) return -1;
   return 0;
}

int cmpnum(const void *ac, const void *bc)
{
   point a,b;

   a = *(point *) ac;
   b = *(point *) bc;

   if(a.num > b.num) return 1;
   if(a.num < b.num) return -1;
   return 0;
}

void buildgraph()
{
   int i;

   p[0].x = -10000;
   p[0].y = -10000;
   // Sort by X coordinate and then by Y
   qsort((void*)p, n+1, sizeof(point), cmpx);

   for(i=1;i<=n;i++)
   {
      if(i > 1 && p[i-1].x == p[i].x)
	p[i].ar[ p[i].count++ ] = p[i-1].num;

      if(i < n && p[i+1].x == p[i].x)
	p[i].ar[ p[i].count++ ] = p[i+1].num;
   }

   // Sort by Y coordinate and then by X
   qsort((void*)p, n+1, sizeof(point), cmpy);

   for(i=1;i<=n;i++)
   {
      if(i > 1 && p[i-1].y == p[i].y)
	p[i].ar[ p[i].count++ ] = p[i-1].num;

      if(i < n && p[i+1].y == p[i].y)
	p[i].ar[ p[i].count++ ] = p[i+1].num;
   }

   // Sort by Number
   qsort((void*)p, n+1, sizeof(point), cmpnum);
}

int verthow[MAXN];
int horhow[MAXN];
int q[MAXN];
int vis[MAXN];
int qe, qb;
int vert[MAXCOOR*2+1];
int hor[MAXCOOR*2+1];
int badcount;
int last;

int bfs(int start)
{
   int v,i,c;

   memset(vis, 0, sizeof(vis));
   memset(vert, 0, sizeof(vert));
   memset(hor, 0, sizeof(hor));
   vis[start] = 1;

   qe = qb = 0;
   q[qe++] = start;
   p[start].color = 1;

   while(qb < qe)
   {
      v = q[qb++];

      if(p[v].color == 1) c = 1; else c = -1;
      vert[p[v].y + MAXCOOR] += c;
      hor[p[v].x + MAXCOOR] += c;

      for(i=0;i<p[v].count;i++)
	if(!vis[p[v].ar[i]])
	{
	   q[qe++] = p[v].ar[i];
	   vis[p[v].ar[i]] = 1;
	   p[p[v].ar[i]].color = !p[v].color;
	}
   }

   badcount = 0;
   for(i=-MAXCOOR;i<=MAXCOOR;i++)
     if(vert[i+MAXCOOR] < -1 || vert[i+MAXCOOR] > 1 ||
	hor[i+MAXCOOR] < -1 || hor[i+MAXCOOR] > 1)
     {
       last = i;
       return 0;
     }

   return 1;
}

void dfs(int v)
{
   int i;

   p[v].comp = comps;

   for(i=0;i<p[v].count;i++)
     if(!p[ p[v].ar[i] ].comp)
       dfs(p[v].ar[i]);
}

void solveit()
{
   int i;

   for(i=1;i<=n;i++)
   {
      verthow[p[i].y + MAXCOOR]++;
      horhow[p[i].x + MAXCOOR]++;
   }

   for(i=1;i<=n;i++) if(!p[i].comp)
   {
      comps++;
      dfs(i);
   }

   for(i=1;i<=n;i++)
     if(!solved[p[i].comp])
     {
	if(bfs(i))
	{
	   solved[p[i].comp] = 1;
	}
     }

   ofstream fout("color.out");
   for(i=1;i<=n;i++)
     fout << p[i].x << " " << p[i].y << " " << p[i].color << endl;
   fout.close();
}

void main()
{
   readdata();
   buildgraph();
   solveit();
}