#include <stdlib.h>
#include <stdio.h>

int n;
int *xc, *yc;
char *srows, *scols, *color;
int minrn = 2000;
int maxrn = -2000;
int mincn = 2000;
int maxcn = -2000;
const char *INFILE = "COLOR.INP";
const char *OUTFILE = "COLOR.OUT";

void colorpoint(int);
int correctrow(int);
int correctcol(int);
void main(int, char**); 

void colorpoint(int i)
{
  int x = xc[i], y = yc[i];
  char c;
  c = abs(srows[y]) > abs(scols[x]) ? srows[y] : scols[x];
  c = c > 0 ? 0 : 1;
  color[i] = c;
  if (!c) c = -1;
  srows[y] += c;
  scols[x] += c;
}

int *rowchk;
int nrowchk = 0;

int correctrow(int i)
{
  int j, nok = abs(srows[i])-1;
  char c, cc, sc;

  for (j = 0; j < nrowchk && i != rowchk[j]; ++j) ;
  if (j < nrowchk) return 0;
  c = srows[i] > 0;
  cc = c?-2:2;
  for (j = 0;  nok > 0 && j < n; ++j)
    if (yc[j] == i && color[j] == c) {
      color[j] = !c;
      srows[i] += cc;
      sc = scols[xc[j]] += cc;
      nok -= 2;
      if (sc < -1 || sc > 1) {
        rowchk[nrowchk++] = i;
        if (!correctcol(xc[j])) {
          nok += 2;
          color[j] = c;
          srows[i] -= cc;
          scols[xc[j]] -= cc;
        }
        --nrowchk;
      }
    }
  return nok < 1;
}

int *colchk;
int ncolchk = 0;

int correctcol(int i)
{
  int j, nok = abs(scols[i])-1;
  char c, cc, sc;

  for (j = 0; j < ncolchk && i != colchk[j]; ++j) ;
  if (j < ncolchk) return 0;
  c = scols[i] > 0;
  cc = c?-2:2;
  for (j = 0;  nok > 0 && j < n; ++j)
    if (xc[j] == i && color[j] == c) {
      color[j] = !c;
      scols[i] += cc;
      sc = srows[yc[j]] += cc;
      nok -= 2;
      if (sc < -1 || sc > 1) {
        colchk[ncolchk++] = i;
        if (!correctrow(yc[j])) {
          nok += 2;
          color[j] = c;
          scols[i] -= cc;
          srows[yc[j]] -= cc;
        }
        --ncolchk;
      }
    }
  return nok < 1;
}

void main (int argc, char **argv)
{
  FILE *f;
  setvbuf(f, NULL, _IOFBF, 8192);
  int x, y, i;

  f = fopen(INFILE, "rt");
  setvbuf(f, NULL, _IOFBF, 8192);
  fscanf(f, "%d", &n);
  xc = new int[n];
  yc = new int[n];
  color = new char[n];
  if (xc == NULL || yc == NULL || color == NULL) {
    printf("Out of memory(1)!");
    exit(1);
  }
  for (i = 0; i < n; ++i) {
    fscanf(f, "%d %d", &x, &y);
    if (y < minrn) minrn = y;
    if (y > maxrn) maxrn = y;
    if (x < mincn) mincn = x;
    if (x > maxcn) maxcn = x;
    xc[i] = x; yc[i] = y; color[i] = 0;
  }
  fclose(f);
  maxrn -= minrn -1;        // Num of rows
  maxcn -= mincn -1;        // Num of cols
  srows = new char[maxrn];
  scols = new char[maxcn];
  rowchk = new int[maxrn];
  colchk = new int[maxcn];
  if (srows == NULL || scols == NULL || rowchk == NULL || colchk == NULL) {
    printf("Out of memory(2)!");
    exit(1);
  }
  for (i = 0; i < maxrn; ++i) srows[i] = 0;
  for (i = 0; i < maxcn; ++i) scols[i] = 0;
  for (i = 0; i < n; ++i) {
    xc[i] -= mincn; yc[i] -= minrn;
  }

  for (i = 0; i < n; ++i)
    colorpoint(i);
  for (i = 0; i < maxrn; ++i)
    if (srows[i] < -1 || srows[i] > 1) {
      correctrow(i);
    }
  for (i = 0; i < maxcn; ++i)
    if (scols[i] < -1 || scols[i] > 1) {
      correctcol(i);
    }

  f = fopen(OUTFILE, "wt");
  setvbuf(f, NULL, _IOFBF, 8192);
  for (i = 0; i < n; ++i) {
    fprintf(f, "%d %d %d\n", xc[i]+mincn, yc[i]+minrn, (int)(color[i]));
  }
  fclose(f);
  delete[] xc;
  delete[] yc;
  delete[] color;
  delete[] srows;
  delete[] scols;
  delete[] rowchk;
  delete[] colchk;
}