package test4;

import java.io.*;
import java.util.StringTokenizer;

public class test4 {

  private String inFName = "COLOR.INP";
  private String outFName = "COLOR.OUT";

  private int nPoints;                     // The number of points
  private Point[] pt;                      // Points data
  private Point point;                     // Pointer to current Point

  private int[] lineSum = new int[2001];   // Colors sum by lines
  private int[] colSum  = new int[2001];   //            by columns

//private int[] stack = new int[6006002];  // (Max number of points=2001*2001)*3/2
  private int stack = new int[22500];      // 15000*3/2 (Max number of points=15000)
  private int stCount = 0;                 // Stack offset

  // Algorithm start -----------------------------------------------------------

  private void computeColors() {
    int difLine, difCol, last = 1;          // Start with a black point
    for(int i=0; i < nPoints; i++) {
      point = pt[i];                        // Avoid multiple index computation
      difLine = lineSum[point.y];
      difCol  = colSum[point.x];
      if ((difLine == 0)&&(difCol == 0)) {  // Can be changed so we remember
        push(difLine);                      // that position, difLine and difCol
        push(difCol);                       // so we can restore and change
        push(i);                            // them on color error
        setColor(last = -last);
      }
      else if (difLine == -difCol) {        // Error! We turn back to the last
        point = pt[i = pop()]; 	            // changable position and change
        colSum[point.x]  = pop();           // it's color, colSum and lineSum
        lineSum[point.y] = pop();
        setColor(last = -point.c);
      }
      else if (difLine != 0)
        setColor(last = -difLine);
      else // if (difCol != 0) always true
        setColor(last = -difCol);
    }
  }

  private void setColor(int c) {
    point.setColor(c);
    colSum[point.x]  += c;                  // Adding the color to the
    lineSum[point.y] += c;                  // column and line sums
  }

  private void push(int i) { stack[stCount++] = i; }

  private int pop() { return stack[--stCount]; }

  // Algorithm end -------------------------------------------------------------

  private void loadPixels() throws Exception {
    BufferedReader lineIn = new BufferedReader(new InputStreamReader(new FileInputStream(inFName)));
    nPoints = Integer.parseInt(lineIn.readLine());
    pt = new Point[nPoints];
    String aLine;
    String iStr;
    for (int i=0; i < nPoints; i++) {
      aLine = lineIn.readLine();
      StringTokenizer s = new StringTokenizer(aLine," ");
      pt[i] = new Point(Integer.parseInt(s.nextToken())+1000, // Translate
                        Integer.parseInt(s.nextToken())+1000);// the coordinates
      s = null;
    }
    lineIn.close();
  }

  private void savePixels() throws Exception {
    DataOutputStream out = new DataOutputStream( new FileOutputStream(outFName));
    for (int i=0; i < nPoints; i++) {
      out.writeBytes(pt[i].toString());
      out.writeByte(13);
      out.writeByte(10);
    }
    out.flush();
    out.close();
  }

  public test4() {
    try {
      loadPixels();
      computeColors();
      savePixels();
    }
    catch (Exception ex) {
      System.out.println(ex.toString());
    }
  }

  // The programm entry
  public static void main(String[] argc) {
    new test4();
  }

class Point {
  public int x,y,c;

  public Point(int x, int y) {
    this.x = x;
    this.y = y;
    c = 0;
  }

  public void setColor(int c) {
    this.c = c;
  }

  public String toString() {
    return (x-1000)+" "+(y-1000)+" "+(c==1?"1":"0"); // Translating back the coordinates
  }
}

}

